Attribute VB_Name = "modOperations"
Option Explicit
Public newxMax, newxMin As Integer
Public newyMax, newyMin As Integer
Public UMax, UMin, VMax, VMin As Integer
Public newX(1 To 10), newY(1 To 10) As Integer

Dim sFactorX, sFactorY As Integer
Dim dy, dx, X1, Y1 As Integer
Dim tempH, tempW As Integer
Dim counter As Integer
Public sFactor As Integer

Public Sub scaleAndFit()
frmDraw.picArea2.DrawWidth = 3

    sFactorX = (UMax - UMin) / (xMax - xMin)
    sFactorY = (VMax - VMin) / (yMax - yMin)
    
    If sFactorX < sFactorY Then
        sFactor = sFactorX
       Else
        sFactor = sFactorY
    End If
    
    For counter = 1 To xyCount
        newX(counter) = x(counter) * sFactor
        newY(counter) = y(counter) * sFactor
    Next counter
    
    newxMin = xMin * sFactor
    newyMin = yMin * sFactor
    
    dx = UMin - newxMin
    dy = VMin - newyMin
    
    For counter = 1 To xyCount
        X1 = newX(counter) + dx
        Y1 = newY(counter) + dy
        frmDraw.picArea2.PSet (X1, frmDraw.picArea2.ScaleHeight - Y1), frmDraw.picArea2.ForeColor
        frmDraw.txtXY(counter - 1).Text = "(" & x(counter) & "," & y(counter) & ")->(" & newX(counter) & "," & newY(counter) & ")"
    Next counter
    
    frmDraw.lblResult.Caption = "Each Points Scaled by " & sFactor & " And Viewport (0,0) corresponds to (" & -dx & "," & -dy & ")"
End Sub

Public Sub reflect()
    frmDraw.picArea2.DrawWidth = 2
    drawXYAxis
    If frmDraw.chkXY(0).Value = 0 And frmDraw.chkXY(1).Value = 0 Then
        MsgBox ("Reflect About Which Axis ?")
        GoTo last
    End If
    
    For counter = 1 To xyCount
        If (frmDraw.chkXY(0).Value = 1) Then
            newX(counter) = x(counter)
            newY(counter) = -y(counter)
        End If
        If (frmDraw.chkXY(1).Value = 1) Then
            newX(counter) = -x(counter)
            newY(counter) = y(counter)
        End If
        If (frmDraw.chkXY(0).Value = 1 And frmDraw.chkXY(1).Value = 1) Then
            newX(counter) = -x(counter)
            newY(counter) = -y(counter)
        End If
        X1 = newX(counter)
        Y1 = newY(counter)
        tempH = frmDraw.picArea2.ScaleHeight / 2
        tempW = frmDraw.picArea2.ScaleWidth / 2
        
        frmDraw.picArea2.PSet (tempW + X1, tempH - Y1), frmDraw.picArea2.ForeColor
        frmDraw.txtXY(counter - 1).Text = "(" & x(counter) & "," & y(counter) & ")->(" & newX(counter) & "," & newY(counter) & ")"
    Next counter
    
last:
    frmDraw.lblResult.Caption = ""
End Sub

Public Sub rotate()
    Dim theta As Double
    Dim pi As Double
    frmDraw.picArea2.DrawWidth = 2
    drawXYAxis
    If frmDraw.txtData.Text = "" Then
        MsgBox ("Enter the Angular Value to Rotate")
        GoTo last
    End If
    theta = frmDraw.txtData.Text
    pi = 3.1415926
    For counter = 1 To xyCount
        newX(counter) = x(counter) * Cos(pi / 180 * theta) - y(counter) * Sin(pi / 180 * theta)
        newY(counter) = x(counter) * Sin(pi / 180 * theta) + y(counter) * Cos(pi / 180 * theta)
        
        X1 = newX(counter)
        Y1 = newY(counter)
        tempH = frmDraw.picArea2.ScaleHeight / 2
        tempW = frmDraw.picArea2.ScaleWidth / 2
        
        frmDraw.picArea2.PSet (tempW + X1, tempH - Y1), frmDraw.picArea2.ForeColor
        frmDraw.txtXY(counter - 1).Text = "(" & x(counter) & "," & y(counter) & ")->(" & newX(counter) & "," & newY(counter) & ")"
    Next counter
    
last:
    frmDraw.lblResult.Caption = ""
End Sub

Public Sub scaleit()
    Dim sVal As Integer
    frmDraw.picArea2.DrawWidth = 2
    drawXYAxis
    If frmDraw.txtData.Text = "" Then
        MsgBox ("Enter the Value to Scale")
        GoTo last
    End If
    sVal = frmDraw.txtData.Text
    
    For counter = 1 To xyCount
        newX(counter) = x(counter) * sVal
        newY(counter) = y(counter) * sVal
        
        X1 = newX(counter)
        Y1 = newY(counter)
        tempH = frmDraw.picArea2.ScaleHeight / 2
        tempW = frmDraw.picArea2.ScaleWidth / 2
        
        frmDraw.picArea2.PSet (tempW + X1, tempH - Y1), frmDraw.picArea2.ForeColor
        frmDraw.txtXY(counter - 1).Text = "(" & x(counter) & "," & y(counter) & ")->(" & newX(counter) & "," & newY(counter) & ")"
    Next counter
last:
    frmDraw.lblResult.Caption = ""
End Sub

Public Sub shear()
    Dim shVal As Integer
    frmDraw.picArea2.DrawWidth = 2
    drawXYAxis
    If frmDraw.txtData.Text = "" Then
        MsgBox ("Enter the Value to Shear")
        GoTo last
    End If
    If frmDraw.chkXY(0).Value = 0 And frmDraw.chkXY(1).Value = 0 _
    Or frmDraw.chkXY(0).Value = 1 And frmDraw.chkXY(1).Value = 1 _
    Then
        MsgBox ("Click one Direction to shear about")
        GoTo last
    End If
    shVal = frmDraw.txtData.Text
    
    For counter = 1 To xyCount
    If frmDraw.chkXY(0).Value = 1 Then
        newX(counter) = x(counter) + (x(counter) * shVal)
        newY(counter) = y(counter)
    End If
    If frmDraw.chkXY(1).Value = 1 Then
        newX(counter) = x(counter)
        newY(counter) = y(counter) + (y(counter) * shVal)
    End If
        X1 = newX(counter)
        Y1 = newY(counter)
        tempH = frmDraw.picArea2.ScaleHeight / 2
        tempW = frmDraw.picArea2.ScaleWidth / 2
        
        frmDraw.picArea2.PSet (tempW + X1, tempH - Y1), frmDraw.picArea2.ForeColor
        frmDraw.txtXY(counter - 1).Text = "(" & x(counter) & "," & y(counter) & ")->(" & newX(counter) & "," & newY(counter) & ")"
    Next counter
last:
    frmDraw.lblResult.Caption = ""
End Sub


Private Sub drawXYAxis()
    frmDraw.picArea2.Line (0, frmDraw.picArea2.ScaleHeight / 2)-(frmDraw.picArea2.ScaleWidth, frmDraw.picArea2.ScaleHeight / 2)
    frmDraw.picArea2.Line (frmDraw.picArea2.ScaleWidth / 2, 0)-(frmDraw.picArea2.ScaleWidth / 2, frmDraw.picArea2.ScaleHeight)
End Sub
